/*
 Copyright (C)2004 Dimax ( http://www.xdimax.com )

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
*/
  
/*
*-------------------------------------------------------------------
* Description: i2cbrdg main device routines
*-------------------------------------------------------------------								 
* Version: $Id: dev_rout.h,v 1.1 2005/03/08 15:57:47 dmitry_kulik Exp $ 									   
*-------------------------------------------------------------------
*/

#ifndef DEV_ROUT_H_INCLUDED
#define DEV_ROUT_H_INCLUDED


#include "i2cbridge.h"

//-----------------------------------------------------------------------------
// Types 
//-----------------------------------------------------------------------------

#define MAX_INPUT_BUFFER_LENGTH     257 // Maximum length of the data we are waiting from device
#define MAX_OUTPUT_BUFFER_LENGTH    264 // Maximum length of the data we are sending to device

typedef struct _DEVICE_REQUEST
{
    UCHAR InputBuffer[MAX_INPUT_BUFFER_LENGTH]; // Buffer received from device
    ULONG InputBufferLength;    // Length of the buffer received from device
    UCHAR OutputBuffer[MAX_OUTPUT_BUFFER_LENGTH]; // Buffer sent to device
    ULONG OutputBufferLength;   // Length of the buffer sent to device
} DEVICE_REQUEST, *PDEVICE_REQUEST;


//-----------------------------------------------------------------------------
// Function Definition
//-----------------------------------------------------------------------------
BYTE dr_get_device_count( void );
HANDLE dr_open_device(BYTE nDevice);
U2C_RESULT dr_close_device(HANDLE hDevice);
U2C_RESULT dr_is_handle_valid(HANDLE hDevice);
U2C_RESULT dr_u2c_transaction( HANDLE hDevice, PDEVICE_REQUEST req );
U2C_RESULT dr_u2c_transaction_pack( HANDLE hDevice, PDEVICE_REQUEST req, int reqc );
U2C_RESULT dr_get_driver_version(HANDLE hDevice, PU2C_VERSION_INFO pVersion);

U2C_RESULT u2c_fw_rc( int rc );
#endif //DEV_ROUT_H_INCLUDED

